#!/usr/bin/python

from historicaldata import *
import random

def evaluate(brian):
	h = HistoricalData()
	reals = 10.0
	btc = 0.0
	
	datasize = len(h.rawdata)-1-10
	for i in range(1,datasize):
		hist = h.deltahistory(i)
		act = brian.activate(hist)
		
		if act > 0:
			if reals > 0:
				if random.random() < act*10:
					btc = h.bid(i+9,reals)
					reals = 0
		elif act < 0:
			if btc > 0:
				if random.random() < -act*10:
					reals += h.ask(i+9,btc)
					btc = 0
	
	if btc > 0:
		if random.random() < -act*10:
			reals += h.ask(datasize,btc)
			btc = 0
	
	return reals
		