#!/usr/bin/python

import random as R
from smallbrain import SmallBrain

population = []
populationprofits = []

print "Initialising..."

def findBest(population):
	bestarg = 0
	best = population[0]
	bestmoney = populationprofits[0]
	
	for p in range(len(population)):
		newmoney = populationprofits[p]
		if newmoney > bestmoney:
			bestarg = p
			best = population[p]
			bestmoney = newmoney
	
	return best, bestmoney, bestarg
		
for i in range(100):
	population.append(SmallBrain())
	profit = population[i].evaluate()
	if profit == 10.0:
		profit = 0.0
	populationprofits.append( profit )

generationnum = 0
while True:
	#best,bestmoney,bestarg = findBest(population)
	#print "Generation %s" % generationnum
	#print "Best brain: %s" % bestarg
	#print "Best profit: %s" % bestmoney
		
	print "Generation %s" % generationnum
	print "Best profit: %s" % max(populationprofits)
	print "Average profit: %f" % (float(sum(populationprofits)) / 100.0)
	print 
	#raw_input()
	generationnum += 1
	
	sortzip = zip(populationprofits, population)
	sortzip.sort(reverse=True)
	populationprofits, population = zip(*sortzip)
	population = list(population)
	populationprofits = list(populationprofits)
	
	populationsize = len(population)

	killTheWeak = R.randint(5,20)
	population = population[:(populationsize-killTheWeak)]
	
	while len(population) < populationsize:
		choice = int(abs(R.normalvariate(0,len(population)/2)))
		if (choice < len(population)):
			newbrain = population[choice].copy()
			population.append( newbrain )
			
	for p in range(len(population)):
		if R.random() < 0.2:
			population[p].mutate()
			
	populationprofits = []
	for brain in population:
		profit = brain.evaluate()
		if profit == 10.0:
			profit = 0.0 # didn't do anything, ever. Fail.
		populationprofits.append(profit)
