#!/usr/bin/python

from pybrain.tools.shortcuts import buildNetwork
from evaluate import *
from historicaldata import *

class SmallBrain:
	def __init__(self):
		self.net = buildNetwork(10, 30, 1)
		
	def shuffle(self):
		self.net.randomize()
		
	def evaluate(self):
		return evaluate(self.net)
	
	def activate(self,thing):
		return self.net.activate(thing)
	
	def mutate(self):
		self.net.mutate()
		
	def copy(self):
		newbrain = SmallBrain()
		newbrain.net = self.net.copy()
		return newbrain

if __name__ == "__main__":
	brian = SmallBrain()
	brian.shuffle()
		
	print brian.net.params
		
	h = HistoricalData()
	print "History"
	print h.history(0)
	print
	print "Historybrain"
	print brian.activate(h.history(0))
	print
	print "DeltaHistory"
	print h.deltahistory(1)
	print
	print "DeltaHistorybrain"
	print brian.activate(h.deltahistory(1))
	print
	print "Final"
	print brian.evaluate()
	